<?php

/**
 * @file
 * Admin page callback file for the og teams module.
 */

/**
 *
 */
function og_teams_add_teams($form_state, $group_node) {
  drupal_set_title(t('Teams for !title', array('!title' => l($group_node->title, "node/$group_node->nid"))));

  $teams = og_teams_teams();
  // If no assignable roles, advise user to add some.
  if (empty($teams)) {
    $destination = drupal_get_destination();
    $teams_url = url('admin/og/og_teams', array('query' => $destination));
    $form['help'] = array(
      '#value' => '<p>' . t('No assignable teams were found. Teams can be created on the <a href="@admin-teams-url">Organic Groups Teams</a> configuration page.', array('@admin-teams-url' => $teams_url)) . '</p>',
    );
    return $form;
  }

  $options = array_map('check_plain', $teams);
  $default = array_keys(og_teams_get_group_teams($group_node->nid));
  $form['og_teams'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Teams'),
    '#default_value' => $default,
    '#options' => $options,
  );

  $form['op'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $group_node->nid,
  );

  return $form;
}

function og_teams_add_teams_submit($form, &$form_state) {
  $teams = $form_state['values']['og_teams'];
  $gid = $form_state['values']['gid'];
  foreach ($teams as $tid => $team) {
    if (empty($team)) {
      og_teams_group_team_delete($gid, $tid);
    }
    else {
      og_teams_group_team_add($gid, $tid);
    }
  }

  //drupal_set_message(format_plural(count($accounts), '1 user added to the group.', '@count users added to the group.'));
  drupal_set_message(t('The changes have been saved.'));
}
