<?php

/**
 * Field handler to provide a list of teams.
 */
class og_teams_views_handler_field_group_teams extends views_handler_field_prerender_list {
  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = array('table' => 'node', 'field' => 'nid');
  }

  function query() {
    $this->add_additional_fields();
    $this->field_alias = $this->aliases['nid'];
  }

  function pre_render($values) {
    $gids = array();
    $this->items = array();

    foreach ($values as $result) {
      $gids[] = $result->{$this->aliases['nid']};
    }

    if ($gids) {
      $result = db_query("SELECT g.gid, g.tid, t.name FROM {og_teams} t INNER JOIN {og_teams_groups} g ON t.tid = g.tid WHERE g.gid IN (" . implode(', ', $gids) . ") ORDER BY t.name");
      while ($team = db_fetch_object($result)) {
        $this->items[$team->gid][$team->tid]['team'] = check_plain($team->name);
        $this->items[$team->gid][$team->tid]['tid'] = $team->tid;
      }
    }
  }

  function render_item($count, $item) {
    return $item['team'];
  }

  function document_self_tokens(&$tokens) {
    $tokens['[' . $this->options['id'] . '-team' . ']'] = t('The name of the team.');
    $tokens['[' . $this->options['id'] . '-tid' . ']'] = t('The team ID of the team.');
  }

  function add_self_tokens(&$tokens, $item) {
    $tokens['[' . $this->options['id'] . '-team' . ']'] = $item['team'];
    $tokens['[' . $this->options['id'] . '-tid' . ']'] = $item['tid'];
  }
}
