<?php

/**
 * Field handler to provide a list of teams.
 */
class og_teams_views_handler_field_user_teams extends views_handler_field_prerender_list {
  function construct() {
    parent::construct();
    $this->additional_fields['uid'] = array('table' => 'users', 'field' => 'uid');
  }

  function query() {
    $this->add_additional_fields();
    $this->field_alias = $this->aliases['uid'];
  }

  function pre_render($values) {
    $uids = array();
    $this->items = array();

    foreach ($values as $result) {
      $uids[] = $result->{$this->aliases['uid']};
    }

    if ($uids) {
      $result = db_query("SELECT u.uid, u.tid, t.name FROM {og_teams} t INNER JOIN {og_teams_users} u ON u.tid = t.tid WHERE u.uid IN (" . implode(', ', $uids) . ") ORDER BY t.name");
      while ($team = db_fetch_object($result)) {
        $this->items[$team->uid][$team->tid]['team'] = check_plain($team->name);
        $this->items[$team->uid][$team->tid]['tid'] = $team->tid;
      }
    }
  }

  function render_item($count, $item) {
    return $item['team'];
  }

  function document_self_tokens(&$tokens) {
    $tokens['[' . $this->options['id'] . '-team' . ']'] = t('The name of the team.');
    $tokens['[' . $this->options['id'] . '-tid' . ']'] = t('The team ID of the team.');
  }

  function add_self_tokens(&$tokens, $item) {
    $tokens['[' . $this->options['id'] . '-team' . ']'] = $item['team'];
    $tokens['[' . $this->options['id'] . '-tid' . ']'] = $item['tid'];
  }
}
